## asymptote 3.01+ds

=== debian/changelog ===
asymptote (3.01+ds-1) unstable; urgency=medium

  * New upstream releaase, redo patches.
    - Exclude libgc & libtinyexr from .orig.tar.gz completely, use the
      libs from system.
    - Update / Clean of d/copyright
  * Lintian clean up.
  * Fix permissions of /usr/share/asymptote/GUI/xasy.py
    (Closes: #1095559).

 -- Hilmar Preuße <hille42@debian.org>  Sun, 02 Mar 2025 19:29:48 +0100

asymptote (2.95+ds-2) unstable; urgency=medium

  * Stop building on armel & armhf until a fixed ghostscript is
    available (see #1085120). This closes: #1091292.

 -- Hilmar Preuße <hille42@debian.org>  Sat, 01 Mar 2025 00:01:01 +0100
