=== debian/changelog ===
asymptote (3.02+ds-1) unstable; urgency=medium

  * New upstream version, refresh patches.
  * Lintian:
    E: asymptote-x11: python3-script-but-no-python3-dep python3
    Thanks to Jeremy Sowden <azazel@debian.org> for help.
    W: old-fsf-address-in-copyright-file

 -- Hilmar Preuße <hille42@debian.org>  Thu, 17 Apr 2025 09:07:30 +0200

asymptote (3.01+ds-3) unstable; urgency=medium

  * A fixed gs package is there, re-upload with Arch "any". Make sure
    that gs 10.04 is not used when building the package.

 -- Hilmar Preuße <hille42@debian.org>  Tue, 18 Mar 2025 22:51:29 +0100

asymptote (3.01+ds-2) unstable; urgency=medium

  * Patch from upstream to fix FTBFS using gcc-15 (Closes: #1096338).

 -- Hilmar Preuße <hille42@debian.org>  Wed, 05 Mar 2025 19:49:43 +0100
