=== debian/watch ===
version=4
opts=repack,repacksuffix=+ds,compression=gz,dversionmangle=s/\+ds// \
http://sf.net/asymptote/asymptote-(.*)\.src\.tgz
