## asymptote 3.04+ds

=== debian/changelog ===
asymptote (3.04+ds-1build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:25:30 +0200

asymptote (3.04+ds-1) unstable; urgency=medium

  * New upstream version, refresh / disable patches.
  * Refresh lintian overrides.

 -- Hilmar Preuße <hille42@debian.org>  Wed, 28 May 2025 09:55:37 +0200

asymptote (3.03+ds-1) unstable; urgency=low

  * New upstream version, refresh patches, add DEP-3 headers to
    two patches.

 -- Hilmar Preuße <hille42@debian.org>  Thu, 15 May 2025 10:37:13 +0200
