## asymptote 3.05%2Bds

=== tests/Makefile ===
.NOTPARALLEL:

TESTDIRS = $(wildcard */)

test: $(TESTDIRS)

$(TESTDIRS)::
	@echo
	../asy -dir ../base $@*.asy

$(EXTRADIRS)::
	@echo
	../asy -dir ../base $@*.asy

clean:  FORCE
	rm -f *.eps

distclean: FORCE clean

FORCE:
