=== debian/control ===
--- 
+++ 
@@ -12,11 +12,11 @@
                dh-python,
                flex,
                cmake,
+               imagemagick,
+               dvisvgm,
                pkgconf,
+               ghostscript (<= 10.03) | ghostscript (>= 10.05),
                libglut-dev,
-               libosmesa6-dev,
-               ghostscript (<= 10.03) | ghostscript (>= 10.05),
-               imagemagick,
                libboost-program-options-dev,
                libboost-filesystem-dev,
                libboost-thread-dev,
@@ -25,6 +25,8 @@
                libfftw3-dev,
                libgc-dev,
                libgsl-dev,
+               libglew-dev,
+               libglm-dev,
                libncurses-dev,
                libreadline-dev,
                libsigsegv-dev,
@@ -44,10 +46,8 @@
                texlive-latex-recommended,
                texlive-fonts-recommended,
                texlive-pstricks,
-               zlib1g-dev,
-               libglm-dev,
-               libglew-dev
-Standards-Version: 4.7.0
+               zlib1g-dev
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://asymptote.sourceforge.net/
 Vcs-Git: https://github.com/debian-tex/asymptote.git
